if (!window.launchpad) {
    window.launchpad = {};
}
if (!window.launchpad.reserve) {
    window.launchpad.reserve = {};
}

launchpad.reserve = {

    beforeMultipleReserveWithForm: function(payload,response, resolve,reject) {
        var arr=[];
        var selections=tvcGetSelectedSelections();
        
        var isChild=false;
        for (var i=0; i<selections.length;i++){
            var truncat = selections[i].defaultValue;
            var idTokens=truncat.split("|");
            if (idTokens[0]!="")
            {
                isChild=true;
                break;
            }
        }
        if(isChild){
            reject(response);
        } else{
            for (var i=0; i<response.length;i++){
                arr.push("model//"+ response[i][0]);
            }
            tvc.invoke.inputParams.formInput=[];
            payload.data=JSON.stringify({"urls":arr});
            resolve(payload);
        }
    },

    tvcCreateBodyForReserveAfterForm:function(formInput){
        var choice=formInput[2].reserveField.values[0].value;
        var userSelectedRef=false;
        var userSelectedInstances=false;
        switch (choice) {
            
            case "INSTANCE":
                userSelectedRef=false;
                userSelectedInstances=true;
                break;
            case "REF":
                userSelectedRef=true;
                userSelectedInstances=false;
                break;
            case "REF|INSTANCE":
                userSelectedRef=true;
                userSelectedInstances=true;
                break;
            default:
                userSelectedRef=false;
                userSelectedInstances=false;
        }
        var arr=[];
        var selections=tvcGetSelectedSelections();
        if(userSelectedInstances){
            for (var i=0; i<tvc.invoke.response.length;i++){
                arr.push("model//"+ tvc.invoke.response[i][0]);
            }
        }
        if(userSelectedRef){
            for (var i=0; i<selections.length;i++){
                var truncat = selections[i].defaultValue;
                var idTokens=truncat.split("|");
                if(idTokens[0]!="")
                {
                    arr.push("model/rel/"+ idTokens[0]);
                }
            }
        }
        tvc.invoke.formInput.body=JSON.stringify({"urls":arr});
    }
};
